import BusX
import CordX
import SwiftUI

extension MeetupId {
  public struct V: View {
    @StateObject var fmt = MeetupId.Formatter(K.textUI, K.textApp)
    @StateObject var isJoinAvailable = Cord.Receive(K.isJoinAvailable, false)
    @StateObject var isLoading = Cord.Receive(K.isLoading, false)
    @StateObject var join = Cord.Button(K.join)
    @StateObject var textField = Cord.TextField(K.textApp, K.textUI)
    let pSEJ = Bus.Processor(shouldEnableJoin, K.M, K.isJoinAvailable)
    
    public init() { }
    
    public var body: some View {
      VStack(spacing: 8) {
        HStack {
          TextField("Binding-3", value: $textField.v, formatter: Cord.TextFieldValueOwner())
            .padding(8)
            .border(Color.blue, width: 2)
          ProgressView()
            .padding(8)
            .opacity(isLoading.v ? 1 : 0)
        }

        Button(action: join.v.send) {
          Text("Join")
            .padding(8)
            .border(
              isJoinAvailable.v ? Color.green : Color.gray,
              width: isJoinAvailable.v ? 4 : 1
            )
        }
        .disabled(!isJoinAvailable.v)
      }
      .frame(width: 320)
      .padding()
    }
  }
}
